--
-- Mod: Animal Worker GUI
--
-- @Author Tunnelrat
-- @Date 06.29.2019
-- @Version 1.0 ..... Change animalWorker settings menu
-- Copyright (C) Tunnelrat, All Rights Reserved.
--

awGui = {};

local awGui_mt = Class(awGui, ScreenElement)

function awGui:new(target, custom_mt)
    local self = ScreenElement:new(target, awGui_mt)
    self.returnScreenName = ""
    return self
end;

function awGui:onOpen()
    awGui:superClass().onOpen(self)
	FocusManager:setFocus(self.backButton)
	-- print("Animal Worker: GUI Opened")
end;

function awGui:onClose()
    awGui:superClass().onClose(self)
	-- print("Animal Worker: GUI Closed")
end;

function awGui:onClickBack()
    awGui:superClass().onClickBack(self)
	animalWorker:updateGui()
	-- print("Animal Worker: Loading GUI settings and saving (menu exit)")
end;

function awGui:onClickOk()
    awGui:superClass().onClickOk(self)
	animalWorker:settingsFromGui(self.awActive:getIsChecked(), self.awFee:getState(), self.awCost:getState(), self.awCapacity:getIsChecked(), self.awPens:getIsChecked())
    self:onClickBack()
	print("Animal Worker: Updating settings from GUI menu...")
end

function awGui:onIngameMenuHelpTextChanged(element)
end

function awGui:onCreateAwGuiHeader(element)
	element.text = g_i18n:getText('gui_aw_Setting')
	print("Animal Worker: Creating GUI elements...")
end

function awGui:onCreateSetWorkerActive(element)
	self.awActive = element
	element.labelElement.text = g_i18n:getText("gui_aw_Active")
	element.toolTipText = g_i18n:getText("gui_aw_ActiveInfo")
end

function awGui:onCreateSetWorkerFee(element)
	self.awFee = element
	element.labelElement.text = g_i18n:getText("gui_aw_Fee")
	element.toolTipText = g_i18n:getText("gui_aw_FeeInfo")
	local wfee = {}
	for i = 1, #animalWorker.fees, 1 do
		wfee[i] = "" .. tostring(animalWorker.fees[i]) .. " %"
	end
	element:setTexts(wfee)
end

function awGui:onCreateSetWorkerCost(element)
	self.awCost = element
	element.labelElement.text = g_i18n:getText("gui_aw_CostPerAnimal")
	element.toolTipText = g_i18n:getText("gui_aw_CostPerAnimalInfo")
	local wcost = {}
	for i = 1, #animalWorker.costs, 1 do
		wcost[i] = "" .. tostring(animalWorker.costs[i]) .. " each"
	end
	element:setTexts(wcost)
end

function awGui:onCreateSetFillCapacity(element)
	self.awCapacity = element
	element.labelElement.text = g_i18n:getText("gui_aw_FillCapacity")
	element.toolTipText = g_i18n:getText("gui_aw_FillCapacityInfo")
end

function awGui:onCreateSetCleanPens(element)
	self.awPens = element
	element.labelElement.text = g_i18n:getText("gui_aw_CleanPens")
	element.toolTipText = g_i18n:getText("gui_aw_CleanPensInfo")
end

function awGui:setActiveStatus(state)
	self.awActive:setIsChecked(state)
end

function awGui:setWorkerFee(indexFee)
	self.awFee:setState(indexFee, false)
end

function awGui:setWorkerCost(indexCost)
	self.awCost:setState(indexCost, false)
end

function awGui:setCapacity(state)
	self.awCapacity:setIsChecked(state)
end

function awGui:setCleanPens(state)
	self.awPens:setIsChecked(state)
end